// Operacoes.cpp : Implementation of COperacoes
#include "stdafx.h"
#include "TesteCOM.h"
#include "Operacoes.h"

/////////////////////////////////////////////////////////////////////////////
// COperacoes


STDMETHODIMP COperacoes::Adicao(LONG lve, LONG lvd, LONG *lvres)
{
	*lvres = lve + lvd;

	return S_OK;
}

STDMETHODIMP COperacoes::AdicaoU(VARIANT lve, VARIANT lvd, VARIANT *lvres)
{
	_variant_t _ve(lve);
	_variant_t _vd(lvd);

	VARTYPE 
		t_ve=_ve.vt,
		t_vd=_vd.vt;

	_variant_t _vres;
	
	if( t_ve == VT_I2 && t_vd == VT_I2 )	// 2 byte signed int
	{
		_vres=_variant_t( long(_ve.iVal + _vd.iVal) );
		_vres.ChangeType( VT_I2 );
	}

	if( t_ve == VT_I4 && t_vd == VT_I4 )	// 4 byte signed int
	{
		_vres=_variant_t( long(_ve.iVal + _vd.iVal) );
		_vres.ChangeType( VT_I4 );
	}

	if( t_ve == VT_BSTR && t_vd == VT_BSTR ) // OLE Automation string
	{
		_vres=_variant_t( _bstr_t(lve) + _bstr_t(lvd) );
		_vres.ChangeType( VT_BSTR );
	}

	/* etc...*/

	*lvres=_vres.Detach();
	
	return S_OK;
}
